package tech.riemann.ims.dto.response;

import club.zhcs.lina.utils.enums.Codebook;
import com.fasterxml.jackson.annotation.JsonGetter;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.nutz.json.JsonField;
import tech.riemann.ims.enums.ApplyTypeEnum;
import tech.riemann.ims.enums.ReviewResultEnum;

/**
 * @author mayong
 * @since 2024/12/6 21:21
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ApplyDTO {

    @Schema(description = "申请id")
    private Long applyId;

    @Schema(description = "申请类型")
    private ApplyTypeEnum applyType;

    @Schema(description = "物料名称")
    private String name;

    @Schema(description = "物料编码")
    private String code;

    @Schema(description = "物料类型")
    private String type;

    @Schema(description = "类型名称")
    private String typeName;

    @Schema(description = "物料规格")
    private String spec;

    @Schema(description = "申请人")
    private String applicant;

    @Schema(description = "审核人")
    private String reviewer;

    @Schema(description = "申请日期")
    private String applyDate;

    @Schema(description = "申请数量")
    private String applyNum;

    @Schema(description = "确认数量")
    private String confirmNum;

    @Schema(description = "备注")
    private String remark;

    @Schema(description = "是否确认")
    private Boolean confirm;

    @Schema(description = "审核状态")
    private ReviewResultEnum reviewResult;

    @JsonGetter
    @JsonField
    public Codebook getApplyTypeInfo() {
        return applyType == null ? null : applyType.build();
    }

    public void setApplyTypeInfo(Codebook areaUnitInfo) {

    }
}
